"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
}), require("@babel/runtime/helpers/objectWithoutPropertiesLoose"), require("@babel/runtime/helpers/extends"), 
require("@emotion/css-prettifier");

var serializer = require("./serializer-69e51a4a.cjs.prod.js"), chalk = _interopDefault(require("chalk")), stylis = require("stylis"), specificity = require("specificity");

function isA(typeName, value) {
  return Object.prototype.toString.apply(value) === "[object " + typeName + "]";
}

function isAsymmetric(obj) {
  return obj && isA("Function", obj.asymmetricMatch);
}

function valueMatches(declaration, value) {
  return value instanceof RegExp ? value.test(declaration.children) : isAsymmetric(value) ? value.asymmetricMatch(declaration.children) : value === declaration.children;
}

function toHaveStyleRule(received, property, value, options) {
  void 0 === options && (options = {});
  var _options = options, target = _options.target, media = _options.media, classNames = serializer.getClassNamesFromNodes([ received ]), cssString = serializer.getStylesFromClassNames(classNames, serializer.getStyleElements()), preparedRules = stylis.compile(cssString);
  media && (preparedRules = serializer.getMediaRules(preparedRules, media));
  var result = preparedRules.filter((function(rule) {
    return "rule" === rule.type && serializer.hasClassNames(classNames, rule.props, target);
  })).reduce((function(acc, rule) {
    var lastMatchingDeclaration = serializer.findLast(rule.children, (function(dec) {
      return "decl" === dec.type && dec.props === property;
    }));
    return lastMatchingDeclaration ? acc.concat(rule.props.map((function(selector) {
      return {
        selector: selector,
        declaration: lastMatchingDeclaration
      };
    }))) : acc;
  }), []).sort((function(_ref, _ref2) {
    var selectorA = _ref.selector, selectorB = _ref2.selector;
    return specificity.compare(selectorA, selectorB);
  })).pop();
  if (!result) return {
    pass: !1,
    message: function() {
      return "Property not found: " + property;
    }
  };
  var declaration = result.declaration, pass = valueMatches(declaration, value);
  return {
    pass: pass,
    message: function() {
      return "Expected " + property + (pass ? " not " : " ") + "to match:\n  " + chalk.green(value) + "\nReceived:\n  " + chalk.red(declaration.children);
    }
  };
}

var matchers = {
  toHaveStyleRule: toHaveStyleRule
};

exports.createSerializer = serializer.createSerializer, exports.default = serializer.serializer, 
exports.matchers = matchers;
